package ic2backpackhud;

import net.minecraftforge.common.config.Configuration;
import net.minecraftforge.common.config.Property;
import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.Loader;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.Mod.Instance;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPostInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;

@Mod(
        modid = IC2BackpackHUD.MODID,
        name = "IC2 Backpack HUD",
        version = IC2BackpackHUD.VERSION,
        dependencies = "required-after:Forge@[10.13.0.1180,)"
        )
public class IC2BackpackHUD {

    public static final String MODID   = "IC2BackpackHUD";
    public static final String VERSION = "3.0";

    @Instance(MODID)
    public static IC2BackpackHUD instance;

    public static boolean showNonElectricItems;
    public static boolean showHelmetItems;
    public static boolean showChestplateItems;
    public static boolean showLeggingItems;
    public static boolean showBootItems;
    public static boolean showLowPowerFlasher;
    public static boolean showChargingFlasher;
    public static boolean showBackground;
    public static int hudPosition;
    public static boolean ic2Loaded = false;

    @EventHandler
    public void preInit(FMLPreInitializationEvent event)
    {
        Configuration config = new Configuration(event.getSuggestedConfigurationFile());
        config.load();

        showNonElectricItems = config.get(Configuration.CATEGORY_GENERAL, "Show HUD for Non-Electric Armor", true).getBoolean(showNonElectricItems);
        showHelmetItems      = config.get(Configuration.CATEGORY_GENERAL,             "Show HUD for Helmet", true).getBoolean(showHelmetItems);
        showChestplateItems  = config.get(Configuration.CATEGORY_GENERAL,         "Show HUD for Chestplate", true).getBoolean(showChestplateItems);
        showLeggingItems     = config.get(Configuration.CATEGORY_GENERAL,           "Show HUD for Leggings", true).getBoolean(showLeggingItems);
        showBootItems        = config.get(Configuration.CATEGORY_GENERAL,              "Show HUD for Boots", true).getBoolean(showBootItems);
        showLowPowerFlasher  = config.get(Configuration.CATEGORY_GENERAL,          "Show Low Power Effects", true).getBoolean(showLowPowerFlasher);
        showChargingFlasher  = config.get(Configuration.CATEGORY_GENERAL,           "Show Charging Effects", true).getBoolean(showChargingFlasher);
        showBackground       = config.get(Configuration.CATEGORY_GENERAL,             "Show HUD Background", true).getBoolean(showBackground);

        Property hudPositionProp = config.get("HUD Position", "hudPosition", 0);

        hudPositionProp.comment = "0 = Horizontal Left of Toolbar\n1 = Horizontal Right of Toolbar\n2 = Vertical Top Left\n3 = Vertical Bottom Left\n4 = Vertical Bottom Right\n5 = Vertical Top Right";
        hudPosition = hudPositionProp.getInt(hudPosition);

        config.save();
    }

    @EventHandler
    public void init(FMLInitializationEvent event)
    {
        FMLCommonHandler.instance().bus().register(new ClientTickHandler());
    }

    @EventHandler
    public void postInit(FMLPostInitializationEvent event)
    {
        ic2Loaded = Loader.isModLoaded("IC2");
    }
}
